var lat;
var lon;
var lonLat;
var zoom;
var source;
var poiLayer;
var content;
var showPopupOnHover = true;
var alt;
var longi;
var lati;
var map;

function drawmap(lon,lat,zoom,source) {
	
	alt = document.getElementById('map');
	alt.innerHTML = '';
	OpenLayers.Lang.setCode('de');

	map = new OpenLayers.Map ("map", {
		controls:[
			new OpenLayers.Control.Navigation(),
/* 			new OpenLayers.Control.PanZoom(), */
/* 			new OpenLayers.Control.LayerSwitcher(), */
			new OpenLayers.Control.ScaleLine(),
			new OpenLayers.Control.MousePosition(),
			new OpenLayers.Control.Attribution()],
	
		maxExtent: new OpenLayers.Bounds(-20037508.34,-20037508.34,20037508.34,20037508.34),
//		maxExtent: new OpenLayers.Bounds(-12,20,12,5),
		maxResolution: 156543.0399,
		numZoomLevels: 18,
		units: 'm',
		projection: new OpenLayers.Projection("EPSG:900913"),
		displayProjection: new OpenLayers.Projection("EPSG:4326")
	} );

//Grundkarte
		
 var newLayer = new OpenLayers.Layer.OSM("Local Tiles", "tiles/${z}/${x}/${y}.png", {numZoomLevels: 20, alpha: true, isBaseLayer: true});
	map.addLayer(newLayer);
 
// Track-Layer			
    var GPX = new OpenLayers.Layer.Vector("E8-Track (1)", {
		strategies: [new OpenLayers.Strategy.Fixed()],
		protocol: new OpenLayers.Protocol.HTTP({
			url: "doc/track0.gpx",
			format: new OpenLayers.Format.GPX()
		}),
		style: {strokeColor: "#ff00ff", strokeWidth: 3, strokeOpacity: 0.8},
		projection: new OpenLayers.Projection("EPSG:4326")
	});
	map.addLayer(GPX);
	
	var GPX = new OpenLayers.Layer.Vector("E8 Track (2)", {
		strategies: [new OpenLayers.Strategy.Fixed()],
		protocol: new OpenLayers.Protocol.HTTP({
			url: "doc/track1.gpx",
			format: new OpenLayers.Format.GPX()
		}),
		style: {strokeColor: "#ff00ff", strokeWidth: 3, strokeOpacity: 0.8},
		projection: new OpenLayers.Projection("EPSG:4326")
	});
	
	map.addLayer(GPX);	
	
	var GPX = new OpenLayers.Layer.Vector("Varianten", {
		strategies: [new OpenLayers.Strategy.Fixed()],
		protocol: new OpenLayers.Protocol.HTTP({
			url: "doc/track2.gpx",
			format: new OpenLayers.Format.GPX()
		}),
		style: {strokeColor: "#00ffff", strokeWidth: 3, strokeOpacity: 0.8},
		projection: new OpenLayers.Projection("EPSG:4326")
	});
	
	map.addLayer(GPX);

 	switch (source) {
		case 0: // POI-Layer 0 =  main	
			poiLayer = new OpenLayers.Layer.Vector("Etappen", { 
				projection: map.displayProjection,
				strategies : [new OpenLayers.Strategy.Fixed()],
				protocol : new OpenLayers.Protocol.HTTP({
					url : 'POI/POI0.kml',
					format : new OpenLayers.Format.KML({
						extractStyles : true,
						extractAttributes : true,
						maxDepth : 10
					})
				}),
			});
		break;
		
		case 1:// POI-Layer 1 = accommodation		
			poiLayer = new OpenLayers.Layer.Vector("Unterkunft", { 
				projection: map.displayProjection,
				strategies : [new OpenLayers.Strategy.Fixed()],
				protocol : new OpenLayers.Protocol.HTTP({
					url : 'POI/POI1.kml',
					format : new OpenLayers.Format.KML({
						extractStyles : true,
						extractAttributes : true,
						maxDepth : 10
					})
				}),
			});
		break;
		
		case 2:// POI-Layer 2 waymarking
			poiLayer = new OpenLayers.Layer.Vector("Wege", {
				projection: map.displayProjection,
				strategies : [new OpenLayers.Strategy.Fixed()],
				protocol : new OpenLayers.Protocol.HTTP({
					url : 'POI/POI2.kml',
					format : new OpenLayers.Format.KML({
						extractStyles : true,
						extractAttributes : true,
						maxDepth : 10
					})
				}),
			});
		break;
		
		case 3:// POI-Layer 3 transportation
			poiLayer = new OpenLayers.Layer.Vector("ÖPNV", {
				projection: map.displayProjection,
				strategies : [new OpenLayers.Strategy.Fixed()],
				protocol : new OpenLayers.Protocol.HTTP({
					url : 'POI/POI3.kml',
					format : new OpenLayers.Format.KML({
						extractStyles : true,
						extractAttributes : true,
						maxDepth : 10
					})
				}),
			});
		break;
		
		default:
			
		break;
	}; 
				
	map.addLayer(poiLayer);
		
	
	var selectControl = new OpenLayers.Control.SelectFeature([poiLayer], {

			toggle : true,
			callbacks : {
				over : function (feature) {
					var labelText = feature.attributes.name || '';
					if (!labelText) return;
					var lonLat = feature.geometry.getBounds().getCenterLonLat();

					var tooltip = new OpenLayers.Popup.Anchored(
							'featureTooltip', // id
							lonLat, // lonlat
							null, // contentSize
							this.html(labelText) // contentHTML
						);

					tooltip.autoSize = true;
					feature.tooltip = tooltip;

					map.addPopup(tooltip);
				},

				out : function (feature) {

					if (feature.tooltip) {
						feature.tooltip.feature = null; // neu
						map.removePopup(feature.tooltip); //neu
						feature.tooltip.destroy();
						feature.tooltip = null;
					}
				}
			},

			onSelect : function (feature) {

				var lati = feature.attributes.lati;
				var longi = feature.attributes.longi;
				var pic = feature.attributes.pic;
				var type = feature.attributes.type;
				var name = feature.attributes.name;
				var link_n = feature.attributes.link_n;
				var table = [feature.attributes.z0, feature.attributes.z1, feature.attributes.z2, feature.attributes.z3, feature.attributes.z4, feature.attributes.z5, feature.attributes.z6, feature.attributes.z7, feature.attributes.z8, feature.attributes.z9, feature.attributes.z10, feature.attributes.z11, feature.attributes.z12, feature.attributes.z13, feature.attributes.z14, feature.attributes.z15, feature.attributes.z16, feature.attributes.z17, feature.attributes.z18, feature.attributes.z19, feature.attributes.z20, feature.attributes.z21, feature.attributes.z22, feature.attributes.z23, feature.attributes.z24, feature.attributes.z25, feature.attributes.z26, feature.attributes.z27, feature.attributes.z28, feature.attributes.z29, feature.attributes.z30, feature.attributes.z31, feature.attributes.z32, feature.attributes.z33, feature.attributes.z34, feature.attributes.z35, feature.attributes.z36, feature.attributes.z37, feature.attributes.z38, feature.attributes.z39, feature.attributes.z40, feature.attributes.z41, feature.attributes.z42, feature.attributes.z43, feature.attributes.z44, feature.attributes.z45, feature.attributes.z46, feature.attributes.z47, feature.attributes.z48, feature.attributes.z49, feature.attributes.z50, feature.attributes.z51, feature.attributes.z52, feature.attributes.z53, feature.attributes.z54, feature.attributes.z55, feature.attributes.z56, feature.attributes.z57, feature.attributes.z58, feature.attributes.z59, feature.attributes.z60, feature.attributes.z61, feature.attributes.z62, feature.attributes.z63, feature.attributes.z64, feature.attributes.z65, feature.attributes.z66, feature.attributes.z67, feature.attributes.z68, feature.attributes.z69, feature.attributes.z70, feature.attributes.z71, feature.attributes.z72];

	// LatLon auf 5 Stellen runden

				lati = lati * 100000;
				lati = Math.round(lati);
				lati = lati / 100000;

				longi = longi * 100000;
				longi = Math.round(longi);
				longi = longi / 100000;

// Popup-Tabellenkopf fuer alle gleich

				content = '<table class="popup"><tr><td width="36px" height="36px" style="background-image: url(share/img/' + type + '.svg); background-repeat: no-repeat;  background-size: contain;"></td><td style="text-align: center"';
				
				

	// verschiedene Popups-Types

				switch (type) {
	// accommodation
					case "area":
						content = content + ' colspan="10"><b>' + name + '</b><hr class="area"></td></tr><tr><td></td>';

						var i = 0;
						var content1 = '';
						while (table[i] != 'end') {
							content1 = content1 + '<td><a href="' + table[i] + '" target="_blank"><img src="share/img/' + table[i + 1] + '.svg" height="36px"></a></td>';
							i += 2;
						};
						content = content + content1 + '</tr></table>';
					break;

					case "pension":
					case "JH":
					case "camp":
					case "hut":
						content = content + '><a href="' + link_n + '" target="_blank"><b>' + name + '</b></a><br><span class="latlon">lat:&nbsp;' + lati + '&nbsp;lon:&nbsp;' + longi + '<hr class="' + type + '"></td></tr><tr><td></td><td>' + table[0] + '</td></tr><tr><td></td><td>' + table[1] + '</td></tr><tr><td></td><td>Tel.:' + table[2] + '&nbsp;&nbsp;<a href="mailto:' + table[3] + '">Mail</a></td></tr></table>';
					break;

					case "shelter":
						content = content + '><b>' + name + '</b><br><span class="latlon">lat:&nbsp;' + lati + '&nbsp;lon:&nbsp;' + longi + '<hr class="shelter"></td></tr><tr><td></td><td>' + table[1] + '</td></tr></table>';
					break;

	// transportation

					case "airport":
					case "busstation":
					case "station":
					case "busstop":
						content = content + ' colspan=3"><a href="' + link_n + '" target="blank"><b>' + name + '</b></a><br><span class="latlon">lat:&nbsp;' + lati + '&nbsp;lon:&nbsp;' + longi + '</span><hr class="' + type + '"></td></tr>';
						var i = 0;
						var content1 = '';
						while (table[i] != 'end') {
							content1 = content1 + '<tr><td class="line">';
							if (!!table[i + 1]) {
								content1 = content1  + '<a href="' + table[i + 1] + '" target="_blank""><b>' + table[i] + '</b></a>';
							} else {
								content1 = content1 + '<b>' + table[i] + '</b>';
							} 
							content1 = content1 + '</td><td>' + table[i + 2] + '</td><td>-</td><td>' + table[i + 3] + '</td></tr>';
							i += 4;
						};
						content = content + content1 + '</table>';
					break;

					case "trafficarea":
						content = '<table style="padding: 8px;"><tr><td><img src="img/' + pic + '.png"></td><td><a href="' + link_n + '"><b>' + name + '</b></td></tr></table>'
					break;

					case "train":
						content = content + '>Bahnstrecke&nbsp;<b>' + name + '</b><hr class="' + type + '"></td></tr>';
					break;
					
	// waymarking

					case "mark":
						content = content + ' colspan="2" style="text-align: center"><b>' + name + '</b><br><span class="latlon">lat:&nbsp;' + lati + '&nbsp;lon:&nbsp;' + longi + '</span><br><hr class="mark">';

						if (!!table[0]) {
							content = content + '<tr><td rowspan="2"><img src="img/left.jpg"></td><td>' + table[0] + '</td><td rowspan="2"><img src="img/' + table[2] + '.jpg"></td></tr><tr><td class="latlon"><a href="' + table[10] + '" target="_blank">' + table[1] + '</a></td></tr>'
						};

						if (!!table[3]) {
							content = content + '<tr><td rowspan="2"><img src="img/' + table[5] + '.jpg"></td><td>' + table[3] + '</td><td rowspan="2"><img src="img/right.jpg"></td></tr><tr><td class="latlon"><a href="' + table[11] + '" target="_blank">' + table[4] + '</a></td></tr>'
						};

						if (!!table[7]) {
							content = content + '<tr><td rowspan="2"><img src="img/' + table[6] + '.jpg"></td><td>' + table[7] + '</td><td rowspan="2"><img src="img/' + table[9] + '.jpg"></td></tr><tr><td class="latlon"><a href="' + table[12] + '" target="_blank">' + table[8] + '</a></td></tr>'
						};

						content = content + '</table>';

					break;

	//	main

					case "startstop":
						content = content + '><a href="#X' + link_n + '"><b>' + link_n + '. Etappe</b></a><br><span class="latlon">lat:&nbsp;' + lati + '&nbsp;lon:&nbsp;' + longi + '</span><hr class="startstop"></td></tr><tr><td></td><td><b>' + name + '&nbsp;-&nbsp;' + table[1] + '</b></td></tr><tr><td colspan="2"><img src="img/hp/'+link_n+'.svg" title="Höhenprofil" alt="Höhenprofil" class="hp"></td></tr><tr><td></td><td>(' + table[2] + '&nbsp;km,&nbsp;Anstieg:&nbsp;' + table[3] + '&nbsp;hm)</td></tr></table>';
						break;

					case "stop":
						content = content + '>' + name + '<br><span class="latlon">lat:&nbsp;' + lati + '&nbsp;lon:&nbsp;' + longi + '</span><hr class="startstop"></td></tr><td></td><td>Weiter geht es nach:&nbsp;<b>' + table[1] + '</b></tr></td></table>';
						break;
						
					default:
						content = '';
						break;
					};

			
				var lonLat = feature.geometry.getBounds().getCenterLonLat();

				popup = new OpenLayers.Popup.FramedCloud(
						'featurePopup', // id
						lonLat, // lonlat
						null, // contentSize
						content , // contentHTML
						null , //anchor
						true //CloseBox
					);

				feature.popup = popup;
				map.addPopup(popup, true);
			},

			
			onUnselect : function (feature) {

				if (feature.popup) {
					popup.feature = null;
					map.removePopup(feature.popup);
					feature.popup.destroy();
					feature.popup = null;
				}
			},

			html : function (text) {
				if (text == null)
					return '';
				return (text + '').replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
			}
		}
	);

	map.addControl(selectControl);
	selectControl.activate();
	jumpTo(lon, lat, zoom);
	
}		

function jumpTo(lon, lat, zoom) {
	var x = Lon2Merc(lon);
	var y = Lat2Merc(lat);
	map.setCenter(new OpenLayers.LonLat(x, y), zoom);
	return false;
}

function Lon2Merc(lon) {
	return 20037508.34 * lon / 180;
}

function Lat2Merc(lat) {
	var PI = 3.14159265358979323846;
	lat = Math.log(Math.tan((90 + lat) * PI / 360)) / (PI / 180);
	return 20037508.34 * lat / 180;
};	

	
	 
	 
	 
	 